=== modified file 'bzr-handle-patch'
--- bzr-handle-patch	2009-11-13 19:07:28 +0000
+++ bzr-handle-patch	2010-04-13 15:06:17 +0000
@@ -25,7 +25,7 @@
 	try:
 		directive = merge_directive.MergeDirective.from_lines(lines)
 	except errors.NotAMergeDirective:
-		controller = DiffController(path, lines)
+		controller = DiffController(path, lines, allow_dirty=True)
 	else:
 		controller = MergeDirectiveController(path, directive)
 	window = controller.window

=== modified file 'diff.py'
--- diff.py	2010-02-24 07:47:17 +0000
+++ diff.py	2010-04-13 15:06:17 +0000
@@ -17,6 +17,7 @@
 import os
 import re
 import sys
+import inspect
 try:
     from xml.etree.ElementTree import Element, SubElement, tostring
 except ImportError:
@@ -524,9 +525,10 @@
 
 class DiffController(object):
 
-    def __init__(self, path, patch, window=None):
+    def __init__(self, path, patch, window=None, allow_dirty=False):
         self.path = path
         self.patch = patch
+        self.allow_dirty = allow_dirty
         if window is None:
             window = DiffWindow(operations=self._provide_operations())
             self.initialize_window(window)
@@ -538,7 +540,12 @@
 
     def get_diff_sections(self):
         yield "Complete Diff", None, ''.join(self.patch)
-        for patch in parse_patches(self.patch):
+        # allow_dirty was added to parse_patches in bzrlib 2.2b1
+        if 'allow_dirty' in inspect.getargspec(parse_patches).args:
+            patches = parse_patches(self.patch, allow_dirty=self.allow_dirty)
+        else:
+            patches = parse_patches(self.patch)
+        for patch in patches:
             oldname = patch.oldname.split('\t')[0]
             newname = patch.newname.split('\t')[0]
             yield oldname, newname, str(patch)

